config/routes.rb
Rails.application.routes.draw do


  get 'logout' => 'sessions#logout'
  get 'login' => 'sessions#login'
  post 'login_process' => 'sessions#login_process'
  get 'welcome_user' => 'sessions#welcome_user'
  get 'student_rank' => 'students#student_rank'

  
  resources :student_marks
  resources :subjects
  resources :students
  resources :users
  resources :roles

  root 'sessions#login'

  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

app/models/subject.rb
class Subject < ApplicationRecord
  belongs_to :user

  validates_uniqueness_of :user_id #, scope: :subject_id
  validates_uniqueness_of :sub_code, presence: true, :message => "Already Exists"
end

app/controllers/subjects_controller.rb
class SubjectsController < ApplicationController
  before_action :set_subject, only: [:show, :edit, :update, :destroy]

  # GET /subjects
  # GET /subjects.json
  def index
    @subjects = Subject.all
  end

  # GET /subjects/1
  # GET /subjects/1.json
  def show
  end

  # GET /subjects/new
  def new
    @subject = Subject.new
  end

  # GET /subjects/1/edit
  def edit
  end

  # POST /subjects
  # POST /subjects.json
  def create
    @subject = Subject.new(subject_params)
    
    respond_to do |format|
      if @subject.save
        format.html { redirect_to subjects_url, notice: 'Subject was successfully created.' }
        format.json { render :show, status: :created, location: @subject }
      else
        format.html { render :new }
        format.json { render json: @subject.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /subjects/1
  # PATCH/PUT /subjects/1.json
  def update
    respond_to do |format|
      if @subject.update(subject_params)
        format.html { redirect_to subjects_url, notice: 'Subject was successfully updated.' }
        format.json { render :show, status: :ok, location: @subject }
      else
        format.html { render :edit }
        format.json { render json: @subject.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /subjects/1
  # DELETE /subjects/1.json
  def destroy
    @subject.destroy
    respond_to do |format|
      format.html { redirect_to subjects_url, notice: 'Subject was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_subject
      @subject = Subject.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def subject_params
      params.require(:subject).permit(:sub_name, :sub_code, :user_id)
    end
end

app/helpers/subjects_helper.rb
module SubjectsHelper
end

app/views/subjects/_form.html.erb
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css"><link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">

<%= form_with(model: subject, local: true) do |form| %>
  <% if subject.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(subject.errors.count, "error") %> prohibited this subject from being saved:</h2>

      <ul>
        <% subject.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>
  <div class="container">
    <div class="row">
      <div class="col-4 form-group row">
        <div class="col-md-4">
          <%= form.label :sub_name, class: "col-form-label" %>
        </div>
        <div class="col-md-8">
          <%= form.text_field :sub_name, id: :sub_sub_name, class: "form-control", required: true %>
        </div>
      </div>
    </div>

    <div class="row">
      <div class="col-4 form-group row">
        <div class="col-md-4">
          <%= form.label :sub_code, class: "col-form-label" %>
        </div>
        <div class="col-md-8">
          <%= form.text_field :sub_code, id: :sub_sub_code, class: "form-control", required: true %>
        </div>
      </div>
    </div>

    <div class="row">
      <div class="col-4 form-group row">
        <div class="col-md-4">
          <%= form.label :teacher, class: "col-form-label" %>
        </div>
        <div class="col-md-8">
          <%= form.collection_select(:user_id,User.where(role_id:2), :id,:user_name, {prompt: true}, {id: :teacher_dropdown}) %>
        </div>
      </div>
    </div>
    
    <div class="actions">
      <%= form.submit "Submit", class:"btn btn-primary float-right" %>
      <%= link_to "Cancel", subjects_path, class: "btn btn-warning float-right mr-3" %>
    </div>
  </div>
<% end %>

app/views/subjects/edit.html.erb
<h1>Editing Subject</h1>

<%= render 'form', subject: @subject %>

<%#= link_to 'Show', @subject, class: "btn btn-info float-right mr-3" %> 

app/views/subjects/index.html.erb
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css"><link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
<script src="https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js"> </script>

<br>
<div style="margin-top: 50px" class="row page-titles">
  <div class="col-md-5 align-self-center">
    <h3 class="text-primary">Subjects</h3>
  </div>
</div>

<div class="container">
  <div class="card top">
    <div class="row">
      <div class="col-md-1 pull-right">
        <%= link_to 'New', new_subject_path , class: "btn btn-info float-right mr-3" %> 
      </div>
      <div class="col-md-1 pull-right">
        <%= link_to 'Back', welcome_user_path , class: "btn btn-warning float-right mr-3" %>
      </div>
    </div>
  </div>
</div>
<br>

<table id="subject_list">
  <thead>
    <tr>
      <th>Sub name</th>
      <th>Sub code</th>
      <th>Teacher Name</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @subjects.each do |subject| %>
      <tr>
        <td><%= subject.sub_name %></td>
        <td><%= subject.sub_code %></td>
        <td><%= subject.user.user_name %></td>
        <td><%= link_to "<i class='fa fa-eye' title='Subject'></i>".html_safe, subject %></td>
        <td><%= link_to "<i class='fa fa-pencil' title='Edit Subject'></i>".html_safe, edit_subject_path(subject) %></td>
        <td><%= link_to "<i class='fa fa-trash' title='Delete Subject'></i>".html_safe, subject, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<script type="text/javascript">
  $(document).ready(function(){
    $('#subject_list').dataTable();
  });
</script>

app/views/subjects/new.html.erb
<h1>New Subject</h1>

<%= render 'form', subject: @subject %>

app/views/subjects/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Sub name:</strong>
  <%= @subject.sub_name %>
</p>

<p>
  <strong>Sub code:</strong>
  <%= @subject.sub_code %>
</p>

<p>
  <strong>User:</strong>
  <%= @subject.user.user_name %>
</p>

<%= link_to 'Edit', edit_subject_path(@subject), class: "btn btn-danger float-right mr-3" %> 
<%= link_to "Back", subjects_path, class: "btn btn-warning float-right mr-3" %>